#pragma once
#include <string>

namespace J3ML::LinearAlgebra {
    class Vector2i;
}

class J3ML::LinearAlgebra::Vector2i {
public:
    int x, y;
public:
    Vector2i();
    Vector2i(int x, int y) : x(x), y(y) {}
    explicit Vector2i(int rhs) : x(rhs), y(rhs) {}
public:
    bool operator == (const Vector2i& rhs) const;
    bool operator != (const Vector2i& rhs) const;
    Vector2i& operator =(const Vector2i& rhs);
    Vector2i& operator +=(const Vector2i& rhs);
    Vector2i& operator -=(const Vector2i& rhs);
    Vector2i& operator *=(const Vector2i& rhs);
    Vector2i& operator /=(const Vector2i& rhs);
    Vector2i operator +(const Vector2i& rhs) const;
    Vector2i operator -(const Vector2i& rhs) const;
    Vector2i operator *(const Vector2i& rhs) const;
    Vector2i operator *(int rhs) const;
    Vector2i operator /(const Vector2i& rhs) const;
    Vector2i operator /(int rhs) const;
public:
    [[nodiscard]] std::string ToString() const;
};