#include <J3ML/LinearAlgebra/Vector2i.hpp>

J3ML::LinearAlgebra::Vector2i &J3ML::LinearAlgebra::Vector2i::operator =(const Vector2i& rhs) {
    x = rhs.x;
    y = rhs.y;
    return *this;
}

bool J3ML::LinearAlgebra::Vector2i::operator ==(const Vector2i& rhs) const {
    return (x == rhs.x && y == rhs.y);
}

bool J3ML::LinearAlgebra::Vector2i::operator !=(const Vector2i& rhs) const {
    return !(*this == rhs);
}

J3ML::LinearAlgebra::Vector2i& J3ML::LinearAlgebra::Vector2i::operator +=(const Vector2i& rhs) {
    x += rhs.x;
    y += rhs.y;
    return *this;
}

J3ML::LinearAlgebra::Vector2i& J3ML::LinearAlgebra::Vector2i::operator -=(const Vector2i& rhs) {
    x -= rhs.x;
    y -= rhs.y;
    return *this;
}

J3ML::LinearAlgebra::Vector2i& J3ML::LinearAlgebra::Vector2i::operator *=(const Vector2i& rhs) {
    x *= rhs.x;
    y *=rhs.y;
    return *this;
}

J3ML::LinearAlgebra::Vector2i& J3ML::LinearAlgebra::Vector2i::operator /=(const Vector2i& rhs) {
    x /= rhs.x;
    y /=rhs.y;
    return *this;
}

J3ML::LinearAlgebra::Vector2i J3ML::LinearAlgebra::Vector2i::operator +(const Vector2i& rhs) const {
    return {x + rhs.x, y + rhs.y};
}

J3ML::LinearAlgebra::Vector2i J3ML::LinearAlgebra::Vector2i::operator -(const Vector2i& rhs) const {
    return {x - rhs.x, y - rhs.y};
}

J3ML::LinearAlgebra::Vector2i J3ML::LinearAlgebra::Vector2i::operator *(const Vector2i& rhs) const {
    return {x * rhs.x, y * rhs.y};
}

J3ML::LinearAlgebra::Vector2i J3ML::LinearAlgebra::Vector2i::operator /(const Vector2i& rhs) const {
    return {x / rhs.x, y / rhs.y};
}

std::string J3ML::LinearAlgebra::Vector2i::ToString() const {
    return std::string(std::to_string(x) + " " + std::to_string(y));
}

J3ML::LinearAlgebra::Vector2i::Vector2i() {
    x = 0;
    y = 0;
}

J3ML::LinearAlgebra::Vector2i J3ML::LinearAlgebra::Vector2i::operator *(const int rhs) const {
    return {x * rhs, y * rhs};
}

J3ML::LinearAlgebra::Vector2i J3ML::LinearAlgebra::Vector2i::operator/(int rhs) const {
    return {x / rhs, y / rhs};
}







